from django.models.mptt import *

def node_tree(object_id):
    node_list = nodes.get_list(object_id__exact = object_id,
                               order_by=['lft']
                               )

    stack = []
    for node in node_list:
    # [:] creates a copy of the list, needed because .pop() modifies it on each
    # iteration and mess with the loop
        stack_copy = stack[:]
        for j in stack_copy:
            if j < node.rght:
                stack.pop()

        stack_size = len(stack)

        node.stack = stack_size

        stack.append(node.rght)
        
    return node_list
